Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lmdz_wake_ini.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lmdz_wake_ini.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lmdz_wake_ini.F90	(revision 4727)
@@ -0,0 +1,225 @@
+MODULE lmdz_wake_ini
+IMPLICIT NONE 
+
+
+  ! ============================================================================
+
+
+  ! But : Decrire le comportement des poches froides apparaissant dans les
+  ! grands systemes convectifs, et fournir l'energie disponible pour
+  ! le declenchement de nouvelles colonnes convectives.
+
+  ! State variables : 
+  ! deltatw    : temperature difference between wake and off-wake regions
+  ! deltaqw    : specific humidity difference between wake and off-wake regions
+  ! sigmaw     : fractional area covered by wakes.
+  ! wdens      : number of wakes per unit area
+
+  ! -------------------------------------------------------------------------
+  ! Declaration de variables
+  ! -------------------------------------------------------------------------
+
+  ! Variables a fixer
+!jyg<
+!!  REAL, SAVE                                            :: stark, wdens_ref, coefgw, alpk
+  INTEGER, SAVE, PROTECTED                                         :: prt_level
+  REAL, SAVE, PROTECTED, DIMENSION(2)                              :: wdens_ref
+  REAL, SAVE, PROTECTED                                            :: stark, coefgw, alpk, wk_pupper
+!>jyg
+  REAL, SAVE, PROTECTED                                            :: crep_upper, crep_sol  
+  !$OMP THREADPRIVATE(stark, wdens_ref, coefgw, alpk, wk_pupper, crep_upper, crep_sol)
+
+  REAL, SAVE, PROTECTED                                            :: tau_cv
+  !$OMP THREADPRIVATE(tau_cv)
+  REAL, SAVE, PROTECTED                                            :: rzero, aa0 ! minimal wake radius and area
+  !$OMP THREADPRIVATE(rzero, aa0)
+
+  LOGICAL, SAVE, PROTECTED                                         :: ok_bug_gfl
+  !$OMP THREADPRIVATE(ok_bug_gfl)
+  LOGICAL, SAVE, PROTECTED                                         :: flag_wk_check_trgl
+  !$OMP THREADPRIVATE(flag_wk_check_trgl)
+  INTEGER, SAVE, PROTECTED                                         :: iflag_wk_act
+  !$OMP THREADPRIVATE(iflag_wk_act)
+
+  INTEGER, SAVE, PROTECTED                                         :: iflag_wk_check_trgl
+  !$OMP THREADPRIVATE(iflag_wk_check_trgl)
+  INTEGER, SAVE, PROTECTED                                         :: iflag_wk_pop_dyn
+  !$OMP THREADPRIVATE(iflag_wk_pop_dyn)
+
+  INTEGER, SAVE, PROTECTED                                         :: iflag_wk_profile
+  !$OMP THREADPRIVATE(iflag_wk_profile)
+
+  REAL, SAVE, PROTECTED                                            :: wdensmin
+  !$OMP THREADPRIVATE(wdensmin)
+  REAL, SAVE, PROTECTED                                            :: sigmad, hwmin, wapecut, cstart
+  !$OMP THREADPRIVATE(sigmad, hwmin, wapecut, cstart)
+  REAL, SAVE, PROTECTED                                            :: sigmaw_max
+  !$OMP THREADPRIVATE(sigmaw_max)  
+  REAL, SAVE, PROTECTED                                            :: dens_rate
+  !$OMP THREADPRIVATE(dens_rate)
+  REAL, SAVE, PROTECTED                                            :: epsilon_loc
+  !$OMP THREADPRIVATE(epsilon_loc)
+  REAL, SAVE, PROTECTED                                            :: epsim1,RG,RD
+  !$OMP THREADPRIVATE(epsim1,RG,RD)
+
+
+
+CONTAINS
+
+  ! =========================================================================
+  SUBROUTINE wake_ini(rg_in,rd_in,rv_in,prt_lev)
+  ! =========================================================================
+
+  ! **************************************************************
+  ! *
+  ! WAKE                                                        *
+  ! retour a un Pupper fixe                                *
+  ! *
+  ! written by   :  GRANDPEIX Jean-Yves   09/03/2000            *
+  ! modified by :   ROEHRIG Romain        01/29/2007            *
+  ! **************************************************************
+
+  ! -------------------------------------------------------------------------
+  ! Initialisations
+  ! -------------------------------------------------------------------------
+
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+  real eps
+  integer, intent(in) :: prt_lev
+  real, intent(in) :: rg_in,rd_in,rv_in
+
+  prt_level=prt_lev
+  epsilon_loc=1.E-15
+  wapecut=1. ! previously 5.
+  ! Essais d'initialisation avec sigmaw = 0.02 et hw = 10.
+  sigmad=0.02
+  hwmin=10.
+!!  DATA wdensmin/1.e-12/
+  wdensmin=1.e-14
+  ! cc nrlmd
+  sigmaw_max=0.4
+  dens_rate=0.1
+
+  eps = rd_in/rv_in
+  epsim1 = 1.0/eps - 1.0
+  RG=rg_in
+  RD=rd_in
+
+
+  ! cc
+  ! Longueur de maille (en m)
+  ! -------------------------------------------------------------------------
+
+  ! ALON = 3.e5
+  ! alon = 1.E6
+
+  ! Configuration de coefgw,stark,wdens (22/02/06 by YU Jingmei)
+
+  ! coefgw : Coefficient pour les ondes de gravite
+  ! stark : Coefficient k dans Cstar=k*sqrt(2*WAPE)
+  ! wdens : Densite surfacique de poche froide
+  ! -------------------------------------------------------------------------
+
+  ! cc nrlmd      coefgw=10
+  ! coefgw=1
+  ! wdens0 = 1.0/(alon**2)
+  ! cc nrlmd      wdens = 1.0/(alon**2)
+  ! cc nrlmd      stark = 0.50
+  ! CRtest
+  ! cc nrlmd      alpk=0.1
+  ! alpk = 1.0
+  ! alpk = 0.5
+  ! alpk = 0.05
+
+
+
+  crep_upper = 0.9
+  crep_sol = 1.0
+
+  ! Flag concerning the bug in gfl computation
+  ok_bug_gfl = .True.
+  call getin_p('ok_bug_gfl', ok_bug_gfl)
+
+  ! Get wapecut from parameter file
+  wapecut = 1.
+
+print*,'wapecut',wapecut
+  CALL getin_p('wapecut', wapecut)
+print*,'wapecut',wapecut
+
+  ! cc nrlmd Lecture du fichier wake_param.data
+
+
+  ! cc nrlmd Lecture du fichier wake_param.data
+  stark=0.33
+  CALL getin_p('stark',stark)
+  cstart = stark*sqrt(2.*wapecut)
+
+  alpk=0.25
+  CALL getin_p('alpk',alpk)
+  
+  wk_pupper=0.6
+  CALL getin_p('wk_pupper',wk_pupper)
+
+
+!jyg<
+!!  wdens_ref=8.E-12
+!!  CALL getin_p('wdens_ref',wdens_ref)
+  wdens_ref(1)=8.E-12
+  wdens_ref(2)=8.E-12
+  CALL getin_p('wdens_ref_o',wdens_ref(1))    !wake number per unit area ; ocean
+  CALL getin_p('wdens_ref_l',wdens_ref(2))    !wake number per unit area ; land
+!>jyg
+!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!!!!!!!!  Population dynamics parameters    !!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!------------------------------------------------------------------------ 
+
+  iflag_wk_pop_dyn = 0
+  CALL getin_p('iflag_wk_pop_dyn',iflag_wk_pop_dyn) ! switch between wdens prescribed 
+                                                    ! and wdens prognostic
+  iflag_wk_act = 0
+  CALL getin_p('iflag_wk_act',iflag_wk_act) ! 0: act(:)=0.
+                                            ! 1: act(:)=1.
+                                            ! 2: act(:)=f(Wape)
+
+  iflag_wk_profile = 0
+  CALL getin_p('iflag_wk_profile',iflag_wk_profile) ! switch between wdens prescribed 
+                                                    ! and wdens prognostic
+  rzero = 5000.
+  CALL getin_p('rzero_wk', rzero)
+  aa0 = 3.14*rzero*rzero
+!
+  tau_cv = 4000.
+  CALL getin_p('tau_cv', tau_cv)
+
+!------------------------------------------------------------------------ 
+
+  coefgw=4.
+  CALL getin_p('coefgw',coefgw)
+
+  WRITE(*,*) 'stark=', stark
+  WRITE(*,*) 'alpk=', alpk
+  WRITE(*,*) 'wk_pupper=', wk_pupper
+!jyg<
+!!  WRITE(*,*) 'wdens_ref=', wdens_ref
+  WRITE(*,*) 'wdens_ref_o=', wdens_ref(1)
+  WRITE(*,*) 'wdens_ref_l=', wdens_ref(2)
+!>jyg
+  WRITE(*,*) 'iflag_wk_pop_dyn=',iflag_wk_pop_dyn
+  WRITE(*,*) 'iflag_wk_act',iflag_wk_act
+  WRITE(*,*) 'coefgw=', coefgw 
+
+  flag_wk_check_trgl=.false.
+  CALL getin_p('flag_wk_check_trgl ', flag_wk_check_trgl)
+  WRITE(*,*) 'flag_wk_check_trgl=', flag_wk_check_trgl
+  WRITE(*,*) 'flag_wk_check_trgl OBSOLETE. Utilisr iflag_wk_check_trgl plutot'
+  iflag_wk_check_trgl=0 ; IF (flag_wk_check_trgl) iflag_wk_check_trgl=1
+  CALL getin_p('iflag_wk_check_trgl ', iflag_wk_check_trgl)
+  WRITE(*,*) 'iflag_wk_check_trgl=', iflag_wk_check_trgl
+
+ RETURN
+
+END SUBROUTINE wake_ini
+
+END MODULE lmdz_wake_ini
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lsc_scav.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lsc_scav.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lsc_scav.F90	(revision 4727)
@@ -1,11 +1,8 @@
 !$Id $
 
-SUBROUTINE lsc_scav(pdtime,it,iflag_lscav,  &
-!jyg<
-                    aerosol,  &
-!>jyg
+SUBROUTINE lsc_scav(pdtime,it,iflag_lscav, aerosol,  &
                     oliq,flxr,flxs,rneb,beta_fisrt,  &
-                    beta_v1,pplay,paprs,t,tr_seri,d_tr_insc,          &
-                    d_tr_bcscav,d_tr_evap,qPrls) 
+                    beta_v1,pplay,paprs,t,tr_seri,   & 
+                    d_tr_insc,d_tr_bcscav,d_tr_evap,qPrls) 
   USE ioipsl
   USE dimphy
@@ -27,8 +24,8 @@
   include "YOECUMF.h" 
 
+! inputs
   REAL,INTENT(IN)                        :: pdtime ! time step (s)
   INTEGER,INTENT(IN)                     :: it     ! tracer number
-  INTEGER,INTENT(IN)                     :: iflag_lscav ! LS scavenging param:
-!                                             3=Reddy_Boucher2004, 4=3+RPilon.
+  INTEGER,INTENT(IN)                     :: iflag_lscav ! LS scavenging param: 3=Reddy_Boucher2004, 4=3+RPilon.
   REAL,DIMENSION(klon,klev+1),INTENT(IN) :: flxr     ! flux precipitant de pluie
   REAL,DIMENSION(klon,klev+1),INTENT(IN) :: flxs     ! flux precipitant de neige
@@ -51,7 +48,6 @@
   REAL,DIMENSION(klon,klev) :: dxbc       ! tendance temporaire de traceur bc
 
-
 !  variables locales      
- LOGICAL,SAVE :: debut=.true.
+ LOGICAL,SAVE :: debut=.TRUE.
 !$OMP THREADPRIVATE(debut)
 !
@@ -90,20 +86,8 @@
 !$OMP THREADPRIVATE(alpha_r, alpha_s, R_r, R_s)
   REAL           :: pr, ps, ice, water
-  real :: conserv
-!
-!!!!!!!!!!!!!!!!!!!! choix lessivage !!!!!!!!!!!!!!!!!!!!!!!!
-!!  logical,save  :: inscav_fisrt
-!!! $OMP THREADPRIVATE(inscav_first)
-!
-!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!  REAL :: conserv
+!
+!
   IF (debut) THEN
-!
-!  inscav_fisrt=.true.
-!  call getin('inscav_fisrt',inscav_fisrt)
-!  if(inscav_fisrt) then 
-!   print*,'beta from fisrtilp.F90, beta = (z_cond - z_oliq)/z_cond, inscav_fisrt=',inscav_fisrt
-!  else
-!   print*,'beta from Reddy and Bocuher 2004 (original version), inscav_fisrt=',inscav_fisrt
-!  endif
 !
       alpha_r=0.001        !  coefficient d'impaction pour la pluie
@@ -113,6 +97,7 @@
       frac_fine_scav=0.7
       frac_coar_scav=0.7
-!     frac_aer=0.5 ~ droplet size shrinks by evap
+!     Droplet size shrinks by evap
       frac_aer=0.5
+      debut=.FALSE.
 !
       OPEN(99,file='lsc_scav_param.data',status='old', &
@@ -125,7 +110,7 @@
       READ(99,*,end=9998)  frac_coar_scav
       READ(99,*,end=9998)  frac_aer
-9998  Continue
+9998  CONTINUE
       CLOSE(99)
-9999  Continue
+9999  CONTINUE
 
    print*,'alpha_r',alpha_r
@@ -136,5 +121,4 @@
    print*,'frac_coar_scav',frac_coar_scav
    print*,'frac_aer ev',frac_aer
-
 !
   ENDIF !(debut)
@@ -158,14 +142,6 @@
   ENDDO
 
-  DO k=1,klev
-    DO i=1, klon
-     d_tr_insc(i,k,it)=0.
-     d_tr_bcscav(i,k,it)=0.
-     d_tr_evap(i,k,it)=0.
-    ENDDO
-  ENDDO
-
 !  pressure and size of the layer
-  DO k=klev-1, 1, -1
+  DO k=klev, 1, -1
    DO i=1, klon 
      zrho(i,k)=pplay(i,k)/t(i,k)/RD   
@@ -176,25 +152,21 @@
 
 !jyg<
-!!    IF (it.gt.1) THEN                               !  aerosol   
 !! Temporary correction: all non-aerosol tracers are dealt with in the same way.
 !! Should be updated once it has been decided how gases should be dealt with.
-    IF (aerosol(it)) THEN
-!>jyg
+  IF (aerosol(it)) THEN
       frac_ev=frac_aer
-    ELSE                                                !  gas
+  ELSE                                                !  gas
       frac_ev=frac_gas
-    ENDIF
-
+  ENDIF
+!
 !jyg<
-!!    IF (it.gt.1) THEN                               !  aerosol   
-    IF (aerosol(it)) THEN
-!>jyg
-     DO k=1, klev
+  IF (aerosol(it)) THEN ! aerosol
+    DO k=1, klev
       DO i=1, klon 
        scav(i,k)=frac_fine_scav
       ENDDO 
-     ENDDO
-    ELSE                  ! gas
-     DO k=1, klev
+    ENDDO
+  ELSE                  ! gas
+    DO k=1, klev
       DO i=1, klon 
        henry_t=henry*exp(-kk*(1./298.-1./t(i,k)))    !  mol/l/atm
@@ -202,42 +174,37 @@
        scav(i,k)=f_a/(1.+f_a)
       ENDDO 
-     ENDDO
-    ENDIF
-
-   DO k=klev-1, 1, -1
+    ENDDO
+  ENDIF
+
+  DO k=klev-1, 1, -1
     DO i=1, klon 
 !  incloud scavenging
-!   if(inscav_fisrt) then 
-   if (iflag_lscav .eq. 4) then
-      beta=beta_fisrt(i,k)*rneb(i,k)
-   else
-      beta=flxr(i,k)-flxr(i,k+1)+flxs(i,k)-flxs(i,k+1)
-!      beta=beta/zdz(i,k)/oliq/zrho(i,k)
-      beta=beta/zmass(i,k)/oliq
-      beta=MAX(0.,beta)
-   endif ! (iflag_lscav .eq. 4)
-   beta_v1(i,k)=beta    !! for output
+      IF (iflag_lscav .EQ. 4) THEN
+        beta=beta_fisrt(i,k)*rneb(i,k)
+      ELSE
+        beta=flxr(i,k)-flxr(i,k+1)+flxs(i,k)-flxs(i,k+1)
+        beta=beta/zmass(i,k)/oliq
+        beta=MAX(0.,beta)
+      ENDIF ! (iflag_lscav .eq. 4)
+      beta_v1(i,k)=beta    !! for output
 !
       dxin=tr_seri(i,k,it)*(exp(-scav(i,k)*beta*pdtime)-1.)
-!      his_dh(i)=his_dh(i)-dxin*zrho(i,k)*zdz(i,k)/pdtime !  kg/m2/s
       his_dh(i)=his_dh(i)-dxin*zmass(i,k)/pdtime !  kg/m2/s
-      d_tr_insc(i,k,it)=dxin
+      d_tr_insc(i,k,it)=dxin                     !  kg/kg/timestep
 
 !  below-cloud impaction
 !jyg<
-!!    IF (it.eq.1) THEN
-    IF (.NOT.aerosol(it)) THEN
-!>jyg
-      d_tr_bcscav(i,k,it)=0.
-    ELSE
-     pr=0.5*(flxr(i,k)+flxr(i,k+1))
-     ps=0.5*(flxs(i,k)+flxs(i,k+1))
-     water=pr*alpha_r/R_r/rho_water
-     ice=ps*alpha_s/R_s/rho_ice
-     dxbc(i,k)=-3./4.*tr_seri(i,k,it)*pdtime*(water+ice)
-!   add tracers from below cloud scav in his_dh
-     his_dh(i)=his_dh(i)-dxbc(i,k)*zmass(i,k)/pdtime !  kg/m2/s
-     d_tr_bcscav(i,k,it)=dxbc(i,k)
-    ENDIF
+      IF (.NOT.aerosol(it)) THEN
+        d_tr_bcscav(i,k,it)=0.
+      ELSE
+        pr=0.5*(flxr(i,k)+flxr(i,k+1))
+        ps=0.5*(flxs(i,k)+flxs(i,k+1))
+        water=pr*alpha_r/R_r/rho_water
+        ice=ps*alpha_s/R_s/rho_ice
+        dxbc(i,k)=-3./4.*tr_seri(i,k,it)*pdtime*(water+ice)
+!      add tracers from below cloud scav in his_dh
+        his_dh(i)=his_dh(i)-dxbc(i,k)*zmass(i,k)/pdtime !  kg/m2/s
+        d_tr_bcscav(i,k,it)=dxbc(i,k)                   !  kg/kg/timestep
+      ENDIF
 
 !  reevaporation
@@ -245,47 +212,39 @@
       deltaP(i,k)=max(deltaP(i,k),0.)
 
-      if(flxr(i,k+1)+flxs(i,k+1).gt.1.e-16) then
-       beta_ev(i,k)=deltaP(i,k)/(flxr(i,k+1)+flxs(i,k+1))
-      else
-       beta_ev(i,k)=0.
-      endif
+      IF (flxr(i,k+1)+flxs(i,k+1).GT.1.e-16) THEn
+        beta_ev(i,k)=deltaP(i,k)/(flxr(i,k+1)+flxs(i,k+1))
+      ELSE
+        beta_ev(i,k)=0.
+      ENDIF
 
       beta_ev(i,k)=max(min(1.,beta_ev(i,k)),0.)
 
 !jyg
-      
-      if(abs(1-(1-frac_ev)*beta_ev(i,k)).gt.1.e-16) then
+      IF (ABS(1.-(1.-frac_ev)*beta_ev(i,k)).GT.1.e-16) THEN
 ! remove tracers from precipitation owing to release by evaporation in his_dh
-!      dxev=frac_ev*beta_ev(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k)) &
-      dxev=frac_ev*beta_ev(i,k)*his_dh(i) *pdtime/(zmass(i,k)) &
-                                      /(1 -(1-frac_ev)*beta_ev(i,k))
-       his_dh(i)=his_dh(i)*(1 - frac_ev*beta_ev(i,k) / (1 -(1-frac_ev)*beta_ev(i,k)))
-      else
-!       dxev=his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k))
-       dxev=his_dh(i) *pdtime/(zmass(i,k))
-       his_dh(i)=0.
-      endif
+        dxev=frac_ev*beta_ev(i,k)*his_dh(i)*pdtime/zmass(i,k)/(1.-(1.-frac_ev)*beta_ev(i,k))
+        his_dh(i)=his_dh(i)*(1.-frac_ev*beta_ev(i,k)/(1.-(1.-frac_ev)*beta_ev(i,k)))
+      ELSE
+        dxev=his_dh(i)*pdtime/zmass(i,k)
+        his_dh(i)=0.
+      ENDIF
+!
 !      print*,  k, 'beta_ev',beta_ev
 ! remove tracers from precipitation owing to release by evaporation in his_dh
-!!      dxev=frac_ev*deltaP(i,k)*pdtime * his_dh(i) /(zrho(i,k)*zdz(i,k))
+!      dxev=frac_ev*deltaP(i,k)*pdtime * his_dh(i) /(zrho(i,k)*zdz(i,k))
 !rplmd
-!!      dxev=frac_ev*deltaP(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k)) &
-!!                                      /max(flxr(i,k)+flxs(i,k),1.e-16)
-
-
-      d_tr_evap(i,k,it)=dxev
-!!     tendency is further added in phytrac x = x + dx
-    ENDDO !!  do i
-   ENDDO  !! do k
-
-!jyg (20130114)
-   DO i = 1,klon
+!      dxev=frac_ev*deltaP(i,k)*his_dh(i) *pdtime/(zrho(i,k)*zdz(i,k))/max(flxr(i,k)+flxs(i,k),1.e-16)
+
+      d_tr_evap(i,k,it)=dxev       !  kg/kg/timestep
+!
+    ENDDO
+  ENDDO
+!
+  DO i = 1,klon
      qPrls(i,it) = his_dh(i)/max(flxr(i,1)+flxs(i,1),1.e-16)
-   ENDDO
-!jyg end
-
-
+  ENDDO
+!
 ! test de conservation
-      conserv=0.
+!      conserv=0.
 !      DO k= klev,1,-1
 !        DO i=1, klon
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/methox.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/methox.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/methox.F90	(revision 4727)
@@ -65,5 +65,5 @@
 IMPLICIT NONE
 
-#include "YOMCST.h"
+INCLUDE "YOMCST.h"
 
 INTEGER,INTENT(IN)    :: KLON 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/mod_surf_para.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/mod_surf_para.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/mod_surf_para.F90	(revision 4727)
@@ -50,7 +50,6 @@
   SUBROUTINE Init_surf_para(knon)
   USE mod_phys_lmdz_para
-#ifdef CPP_MPI
-  INCLUDE 'mpif.h'
-#endif
+  USE lmdz_mpi
+
     INTEGER :: knon
     INTEGER :: i,ierr
@@ -88,8 +87,6 @@
       
       IF (is_using_mpi) THEN
-#ifdef CPP_MPI
         CALL MPI_ALLGather(knon_mpi,1,MPI_INTEGER,knon_mpi_para,1,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
         CALL MPI_ALLGather(knon_omp_para,omp_size,MPI_INTEGER,knon_glo_para,omp_size,MPI_INTEGER,COMM_LMDZ_PHY,ierr)
-#endif
       ELSE
         knon_mpi_para(:)=knon_mpi
@@ -169,7 +166,6 @@
   SUBROUTINE gather_surf_mpi_i(FieldIn,FieldOut)
   USE mod_phys_lmdz_para
-#ifdef CPP_MPI
-  INCLUDE 'mpif.h'
-#endif
+  USE lmdz_mpi
+
     INTEGER :: FieldIn(:)
     INTEGER :: FieldOut(:)
@@ -177,9 +173,7 @@
     
     IF (is_using_mpi) THEN
-#ifdef CPP_MPI
       CALL MPI_Gatherv(FieldIn,knon_mpi,MPI_INTEGER,                                &
                        FieldOut,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_INTEGER, &
                        mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
     ELSE
       FieldOut(:)=FieldIn(:)
@@ -224,7 +218,6 @@
   SUBROUTINE gather_surf_mpi_r(FieldIn,FieldOut)
   USE mod_phys_lmdz_para
-#ifdef CPP_MPI
-  INCLUDE 'mpif.h'
-#endif
+  USE lmdz_mpi
+
     REAL :: FieldIn(:)
     REAL :: FieldOut(:)
@@ -232,9 +225,7 @@
     
     IF (is_using_mpi) THEN
-#ifdef CPP_MPI
       CALL MPI_Gatherv(FieldIn,knon_mpi,MPI_REAL_LMDZ,                                 &
                        FieldOut,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_REAL_LMDZ,  &
                        mpi_master,COMM_LMDZ_PHY,ierr)            
-#endif
     ELSE
       FieldOut(:)=FieldIn(:)
@@ -277,7 +268,6 @@
   SUBROUTINE scatter_surf_mpi_i(FieldIn,FieldOut)
   USE mod_phys_lmdz_para
-#ifdef CPP_MPI
-  INCLUDE 'mpif.h'
-#endif
+  USE lmdz_mpi
+
     INTEGER :: FieldIn(:)
     INTEGER :: FieldOut(:)
@@ -285,9 +275,7 @@
     
     IF (is_using_mpi) THEN
-#ifdef CPP_MPI
       CALL MPI_Scatterv(FieldIn,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_INTEGER,   &
                         FieldOut,knon_mpi,MPI_INTEGER,                                &
                         mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
     ELSE
       FieldOut(:)=FieldIn(:)
@@ -329,7 +317,6 @@
   SUBROUTINE scatter_surf_mpi_r(FieldIn,FieldOut)
   USE mod_phys_lmdz_para
-#ifdef CPP_MPI
-  INCLUDE 'mpif.h'
-#endif
+  USE lmdz_mpi
+
     REAL :: FieldIn(:)
     REAL :: FieldOut(:)
@@ -337,9 +324,7 @@
     
     IF (is_using_mpi) THEN
-#ifdef CPP_MPI
       CALL MPI_Scatterv(FieldIn,knon_mpi_para,knon_mpi_begin_para(:)-1,MPI_INTEGER,   &
                         FieldOut,knon_mpi,MPI_INTEGER,                                &
                         mpi_master,COMM_LMDZ_PHY,ierr)
-#endif
     ELSE
       FieldOut(:)=FieldIn(:)
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/modd_csts.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/modd_csts.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/modd_csts.F90	(revision 4727)
@@ -0,0 +1,91 @@
+!SFX_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
+!SFX_LIC This is part of the SURFEX software governed by the CeCILL-C licence
+!SFX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
+!SFX_LIC for details. version 1.
+!     ###############
+      MODULE MODD_CSTS      
+!     ###############
+!
+!!****  *MODD_CSTS* - declaration of Physic constants 
+!!
+!!    PURPOSE
+!!    -------
+!       The purpose of this declarative module is to declare  the 
+!     Physics constants.    
+!
+!!
+!!**  IMPLICIT ARGUMENTS
+!!    ------------------
+!!      None 
+!!
+!!    REFERENCE
+!!    ---------
+!!          
+!!    AUTHOR
+!!    ------
+!!      V. Ducrocq   *Meteo France*
+!!
+!!    MODIFICATIONS
+!!    -------------
+!!      Original    16/05/94  
+!!      J. Stein    02/01/95  add xrholw                    
+!!      J.-P. Pinty 13/12/95  add XALPI,XBETAI,XGAMI
+!!      J. Stein    25/07/97  add XTH00                    
+!!      V. Masson   05/10/98  add XRHOLI
+!!      C. Mari     31/10/00  add NDAYSEC
+!!      J. Escobar     06/13  add XSURF_TIMY XSURF_TIMY_12 XSURF_EPSILON for REAL*4
+!-------------------------------------------------------------------------------
+!
+!*       0.   DECLARATIONS
+!             ------------
+!
+IMPLICIT NONE 
+REAL,SAVE :: XPI                ! Pi
+!
+REAL,SAVE :: XDAY,XSIYEA,XSIDAY ! day duration, sideral year duration,
+                                ! sideral day duration
+!
+REAL,SAVE :: XKARMAN            ! von karman constant
+REAL,SAVE :: XLIGHTSPEED        ! light speed
+REAL,SAVE :: XPLANCK            ! Planck constant
+REAL,SAVE :: XBOLTZ             ! Boltzman constant 
+REAL,SAVE :: XAVOGADRO          ! Avogadro number
+!
+REAL,SAVE :: XRADIUS,XOMEGA     ! Earth radius, earth rotation
+REAL,SAVE :: XG                 ! Gravity constant
+!
+REAL,SAVE :: XP00               ! Reference pressure
+!
+REAL,SAVE :: XSTEFAN,XI0        ! Stefan-Boltzman constant, solar constant
+!
+REAL,SAVE :: XMD,XMV            ! Molar mass of dry air and molar mass of vapor
+REAL,SAVE :: XRD,XRV            ! Gaz constant for dry air, gaz constant for vapor
+REAL,SAVE :: XCPD,XCPV          ! Cpd (dry air), Cpv (vapor)
+REAL,SAVE :: XRHOLW             ! Volumic mass of liquid water
+REAL,SAVE :: XCL,XCI            ! Cl (liquid), Ci (ice)
+REAL,SAVE :: XTT                ! Triple point temperature
+REAL,SAVE :: XTTSI              ! Temperature of ice fusion over salty sea
+REAL,SAVE :: XTTS               ! Equivalent temperature of ice fusion over a mixed of sea and sea-ice
+REAL,SAVE :: XICEC              ! Threshold fraction over which the tile is considered as only covered with ice
+REAL,SAVE :: XLVTT              ! Vaporization heat constant
+REAL,SAVE :: XLSTT              ! Sublimation heat constant
+REAL,SAVE :: XLMTT              ! Melting heat constant
+REAL,SAVE :: XESTT              ! Saturation vapor pressure  at triple point
+                                ! temperature  
+REAL,SAVE :: XALPW,XBETAW,XGAMW ! Constants for saturation vapor 
+                                !  pressure  function 
+REAL,SAVE :: XALPI,XBETAI,XGAMI ! Constants for saturation vapor
+                                !  pressure  function over solid ice
+REAL, SAVE        :: XTH00      ! reference value  for the potential
+                                ! temperature
+REAL,SAVE :: XRHOLI             ! Volumic mass of ice
+REAL,SAVE :: XCONDI             ! thermal conductivity of ice (W m-1 K-1)
+!
+INTEGER, SAVE :: NDAYSEC        ! Number of seconds in a day
+!
+REAL,SAVE     :: XSURF_TINY          ! minimum real on this machine
+REAL,SAVE     :: XSURF_TINY_12       ! sqrt(minimum real on this machine)
+REAL,SAVE     :: XSURF_EPSILON       ! minimum space with 1.0
+!
+END MODULE MODD_CSTS
+
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/moy_undefSTD.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/moy_undefSTD.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/moy_undefSTD.F90	(revision 4727)
@@ -8,14 +8,10 @@
   USE phys_state_var_mod
 #endif
-#ifdef CPP_XIOS
-  USE wxios, ONLY: missing_val
-#endif
+  USE wxios, ONLY: missing_val_xios => missing_val, using_xios
  
   USE phys_cal_mod, ONLY: mth_len
   IMPLICIT NONE
   include "clesphys.h"
-#ifndef CPP_XIOS 
   REAL :: missing_val
-#endif
 
   ! ====================================================================
@@ -59,7 +55,9 @@
 
 ! missing_val = nf90_fill_real
-#ifndef CPP_XIOS
-      missing_val=missing_val_nf90
-#endif
+  IF (using_xios) THEN
+    missing_val = missing_val_xios
+  ELSE
+    missing_val=missing_val_nf90
+  ENDIF
 
   DO n = 1, nout
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/nuage.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/nuage.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/nuage.F90	(revision 4727)
@@ -2,9 +2,10 @@
 
 SUBROUTINE nuage(paprs, pplay, t, pqlwp,picefra, pclc, pcltau, pclemi, pch, pcl, pcm, &
-    pct, pctlwp, ok_aie, mass_solu_aero, mass_solu_aero_pi, bl95_b0, bl95_b1, &
-    cldtaupi, re, fl)
+    pct, pctlwp, ok_aie, mass_solu_aero, mass_solu_aero_pi, bl95_b0, bl95_b1, distcltop, &
+    temp_cltop, cldtaupi, re, fl)
   USE dimphy
-  USE lscp_tools_mod, only: icefrac_lscp
+  USE lmdz_lscp_tools, only: icefrac_lscp
   USE icefrac_lsc_mod ! computes ice fraction (JBM 3/14)
+  USE lmdz_lscp_ini, only : iflag_t_glace
   USE phys_local_var_mod, ONLY: ptconv
   IMPLICIT NONE
@@ -49,5 +50,6 @@
 
   REAL pct(klon), pctlwp(klon), pch(klon), pcl(klon), pcm(klon)
-
+  REAL distcltop(klon,klev)
+  REAL temp_cltop(klon,klev)
   LOGICAL lo
 
@@ -112,5 +114,5 @@
 !                           t_glace_max, exposant_glace)
         IF (ok_new_lscp) THEN
-            CALL icefrac_lscp(klon,t(:,k),pplay(:,k)/paprs(:,1),zfice(:),dzfice(:))
+            CALL icefrac_lscp(klon,t(:,k),iflag_ice_thermo,distcltop(:,k),temp_cltop(:,k),zfice(:),dzfice(:))
         ELSE
             CALL icefrac_lsc(klon,t(:,k),pplay(:,k)/paprs(:,1),zfice(:))
@@ -118,12 +120,14 @@
         ENDIF
 
-        IF ((.NOT. ptconv(i,k)) .AND. ok_new_lscp .AND. ok_icefra_lscp) THEN
-        ! EV: take the ice fraction directly from the lscp code
-        ! consistent only for non convective grid points
-        ! critical for mixed phase clouds
-            DO i=1,klon
-            zfice(i)=picefra(i,k)
-            ENDDO
+    IF (ok_new_lscp .AND. ok_icefra_lscp) THEN
+    ! EV: take the ice fraction directly from the lscp code
+    ! consistent only for non convective grid points
+    ! critical for mixed phase clouds
+        DO i=1,klon
+        IF (.NOT. ptconv(i,k)) THEN
+           zfice(i)=picefra(i,k)
         ENDIF
+        ENDDO
+    ENDIF 
 
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/nuage.h
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/nuage.h	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/nuage.h	(revision 4727)
@@ -2,25 +2,14 @@
 ! $Id$
 !
-      REAL rad_froid, rad_chau1, rad_chau2, t_glace_max, t_glace_min
-      REAL exposant_glace
-      REAL rei_min,rei_max
+      REAL rad_froid, rad_chau1, rad_chau2
       REAL tau_cld_cv,coefw_cld_cv
-
       REAL tmax_fonte_cv
-
-      INTEGER iflag_t_glace, iflag_cloudth_vert, iflag_cld_cv
-      INTEGER iflag_rain_incloud_vol
-   
-      INTEGER iflag_gammasat, iflag_vice, iflag_rei
+      INTEGER iflag_cld_cv, iflag_ratqs
       LOGICAL ok_icefra_lscp
 
-      common /nuagecom/ rad_froid,rad_chau1, rad_chau2,t_glace_max,     &
-     &                  t_glace_min,exposant_glace,rei_min,rei_max,     &
+      common /nuagecom/ rad_froid,rad_chau1, rad_chau2,                 &
      &                  tau_cld_cv,coefw_cld_cv,                        &
-     &                  tmax_fonte_cv,                                  &
-     &                  iflag_t_glace,iflag_cloudth_vert,iflag_cld_cv,  &
-     &                  iflag_rain_incloud_vol,                         &
-     &                  ok_icefra_lscp,                  &
-     &                  iflag_gammasat, iflag_vice,       &
-     &                  iflag_rei    
+     &                  tmax_fonte_cv,iflag_ratqs,                      &
+     &                  iflag_cld_cv,                                   &
+     &                  ok_icefra_lscp                                 
 !$OMP THREADPRIVATE(/nuagecom/)
